#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include "tg.h"
#include "fault.h"


#define TIERS_OUTPUT "./output_of_tiers"
#define DEBUG 1
#define START_IP_ADDRESS = "190.0.0.1"
#define SUBNET_MASK "255.255.255.252"

/* Global Variables */
FILE *infd;
FILE *outfd;
int ethernets_num,taps_num;

/* set an environment variable with the full PATH location of tiers */
char *find_tg() 
{
 char *tiers="/q/toltec/home/toltec/psebos/op_admin/generator/bin/tiers";
  /*
 char *tiers=NULL;
 tiers = (char *) getenv("TIERS");
 if (tiers==NULL) {
  printf("Inside\n");
  strcpy(tiers,t);
  printf("Inside\n");
 }
  */
 return(tiers);
}


int run_algorithm (char *option, char *redundancy1, char *redundancy2)
{
 char buffer[255];
 int c;
 char command[255];
 char *tiers;
 /* find tiers */
 tiers = find_tg();
 /* constract the command and run it */
 remove(TIERS_OUTPUT);
 bzero((char *) &command,sizeof(command));
 strncat((char *) &command,tiers, strlen(tiers));
 strncat((char *) &command," 1 1 0 1 ", strlen(" 1 1 0 1 "));
 strncat((char *) &command,option,strlen(option));
 strncat((char *) &command," 0 ", strlen(" 0 "));
 strncat((char *) &command,redundancy1,strlen(redundancy1));
 strncat((char *) &command," ", strlen(" "));
 strncat((char *) &command,redundancy2,strlen(redundancy2));
 strncat((char *) &command," 1 1 1 >",strlen(" 1 1 1 >"));
 strcat((char *) &command,TIERS_OUTPUT);
 if (DEBUG == 1) puts(command);
 if (system(command) < 0) return(-1);
 infd=fopen(TIERS_OUTPUT,"r");
 if (infd == NULL) return(-1);
 /* else */
 return(1);
}


/* calculating the number of edges inside the input file */
void find_edges_number(int *edges_number)
{
 char buffer[255];

 *edges_number=0;
 /* We do not have to open because we have done it when creating */
 /* the command */
 /* infd=fopen(TIERS_OUTPUT,"r"); */
 /* Read until to find MAN 0 */
 bzero(&buffer,sizeof(buffer));
 fgets((char *) &buffer, sizeof(buffer),(FILE *) infd);
 if (DEBUG == 1) fprintf(stderr,"Trying to find # MAN 0 in file\n");
 while((strcmp(buffer,"")!=0) && (memcmp(&buffer,"# MAN 0",7)!=0)) {
  bzero(&buffer,sizeof(buffer));
  fgets((char *) &buffer, sizeof(buffer),(FILE *) infd);
 /*
  if (DEBUG == 1) puts((char *) &buffer);
 */
 }
 /* One more before reading edges */
 fgets((char *) &buffer, sizeof(buffer),(FILE *) infd);

 if (DEBUG == 1) fprintf(stderr,"Ready to get the number of the edges\n");

 /* Read each line till the end of file and substruct 2 */ 
 /* because of EOF reading */
 while(strcmp(buffer,"")!=0) {
   *edges_number=*edges_number+1;
   bzero(&buffer,sizeof(buffer));
   fgets((char *) &buffer, sizeof(buffer),(FILE *) infd);
   /*
   if (DEBUG == 1) puts((char *) &buffer);
   */
 }
 *edges_number=*edges_number-2;
 if (DEBUG == 1) fprintf(stderr,"Have used file %d\n",*infd);
 rewind(infd);
 if (DEBUG == 1) fprintf(stderr,"Have used file %d\n",*infd);
 if (DEBUG == 1) fprintf(stderr,"We have %d edges and I've just rewind the\
  file\n",*edges_number);
}


void circlePlotPoints (int x, int y, int many, position_t *position)
{
  position_t *circle = position;
  switch (many) {
    case 8:
       circle->x = (float) x;
       circle->y = (float) y;
       circle++;
    case 7:
       circle->x = (float) -x;
       circle->y = (float)  y;
       circle++;
    case 6:
       circle->x = (float) +x;
       circle->y = (float) -y;
       circle++;
    case 5:
       circle->x = (float) -x;
       circle->y = (float) -y;
       circle++;
    case 4:
       circle->x = (float)  y;
       circle->y = (float)  x;
       circle++;
    case 3:
       circle->x = (float) -y;
       circle->y = (float)  x;
       circle++;
    case 2:
       circle->x = (float)  y;
       circle->y = (float) -x;
       circle++;
    case 1:
       circle->x = (float) -y;
       circle->y = (float) -x;
       circle++;
       break;
  }
}

void calculate_position(int nodes_num,position_t *position,int radius)
{

 int i;
 float new_x, new_y;
 int counter;
 int nodes_left;
 int p;
 int tmp;
 float d;
 position_t *circle=position;
 

 new_x=0;
 new_y=radius;
 d = ((float) ((4*50)+1)) / ((float) nodes_num);
 nodes_left=nodes_num;

 if (DEBUG == 2) {
   for (tmp=0;tmp<=nodes_num-1;tmp++) {
    printf("Inside node %d x=%f y=%f\n",tmp,circle->x,circle->y);
    circle++;
   }
   circle=position;
 }

 /* OLD CODE FORGET IT
 if (nodes_left != 0) {
     circle->x = new_x;
     circle->y = new_y;
     circle++;
     nodes_left--;
 }
 if (nodes_left != 0) {
     circle->x = new_x;
     circle->y = -new_y;
     circle++;
     nodes_left--;
 }
 new_x+=d;
 new_y-=d;
 */

 /* In first and third tetartimorio draw circle */
 while (((int)new_x <= radius) && (nodes_left != 0)) {
  circle->x = new_x;
  circle->y = new_y;
  circle++;
  nodes_left--;
  if (nodes_left != 0) {
   circle->x = -new_x;
   circle->y = -new_y;
   circle++;
   nodes_left--;
  }
  new_x+=d;
  new_y-=d;
 }
 if (DEBUG == 1)  printf("new_x %d\n",(int)new_x);

 /* if there is already something on the 70,0 then move */
 if ((int)new_x == radius) {
    new_y= -d;
    new_x= (float)radius-d;
 } else { /* place the pointer at 70,0 */
    new_y=0;
    new_x=radius;
   }

 if (DEBUG == 1) printf("Nodes left %d\n",nodes_left);

 /* Secondly in second and fourth tetartimorio draw circle */
 while (((int)new_x >= 0) && (nodes_left != 0)) {
  circle->x = new_x;
  circle->y = new_y;
  circle++;
  nodes_left--;
  if (nodes_left != 0) {
   circle->x = -new_x;
   circle->y = -new_y;
   circle++;
   nodes_left--;
  }
  new_x-=d;
  new_y-=d;
 }
 if (DEBUG == 1)  printf("new_x %d\n",(int)new_x);

 if (DEBUG == 2) {
   for (tmp=0;tmp<=nodes_num-1;tmp++) {
    printf("Inside node %d x=%f y=%f\n",tmp,circle->x,circle->y);
    circle++;
   }
   circle=position;
 }

 /*
 if (DEBUG == 1) {
   printf("d=%f\n",d);
   printf("Nodes num %d\n",nodes_num);
   printf("Nodes left %d\n",nodes_left);
   circle=position;
   for (tmp=0;tmp<=nodes_num-1;tmp++) {
    printf("Inside node %d x=%f y=%f\n",tmp,circle->x,circle->y);
    circle++;
   }
 }
 */



}
 

void create_ema_code(int nodes_num,position_t *position,int edges_num,edge_t *edges, char *output, int senders_num, int receivers_num)
{
 int counter;
 int objects_num;
 char buffer[255];
 char *p,*t;
 int current;
 int i;
 int ethernets_start, taps_start;
 edge_t *original_edges;
 ethernets_t ethernets[ethernets_num];
 taps_t taps[taps_num];
 int start_taps,taps_counter,taps_object,current_client,j;
 float x,y,placement,delta;
 int eth_objects;
 sc_position_t sc_position[nodes_num+senders_num+receivers_num];
 int sc;
 

 /* Keeping edges */
 original_edges=edges;

 objects_num = 2 + nodes_num + (4 * edges_num);
 if (DEBUG == 1) fprintf(stderr,"creating ema code for %d nodes %d edges \
  and %d objects\n",nodes_num,edges_num,objects_num);
 /*
 if (DEBUG == 1) {
   for (counter=0; counter <= nodes_num+1 ; counter++) {
     fprintf(stderr,"%d %d\n",(*position).x,(*position).y);
     fprintf(stderr,"%d %d\n",position->x,position->y);
     position++;
   }
 }
 */

 /* counting the ETHERNET TAPS links */
 ethernets_num = 0;
 taps_num=0;
 for (i=0; i<=nodes_num-1; i++) {
   if (((position+i)->senders != 0) ||
       ((position+i)->receivers != 0)) {
           ethernets_num++; 
   }
   if ((position+i)->senders != 0)   taps_num+=((position+i)->senders+1);
   if ((position+i)->receivers != 0) taps_num+=((position+i)->receivers+1); 
   if (((position+i)->senders != 0) &&
       ((position+i)->receivers != 0)) taps_num--;

 }

 if (DEBUG) {
   printf(" Nodes %d\n Ethernets %d\n Taps %d\n senders %d\n receivers %d\n edges %d\n",nodes_num,ethernets_num,taps_num,senders_num,receivers_num,edges_num);
 }

 /* printing top of the program includes */
 fprintf(outfd,"#include <opnet.h>\n");
 fprintf(outfd,"#include <ema.h>\n");
 fprintf(outfd,"#include <opnet_emadefs.h>\n");
 fprintf(outfd,"#include <opnet_constants.h>\n");
 fprintf(outfd,"\n\n\n");
 fprintf(outfd,"/* array for all textlist attributes in model */\n");
 fprintf(outfd,"Prg_List*\t\tprg_lptr [100];\n\n");
 fprintf(outfd,"/* array for all objects in model */\n");
 fprintf(outfd,"EmaT_Object_Id\t\tobj [%d];\n",nodes_num+senders_num+receivers_num+4*edges_num+3*(ethernets_num+taps_num)+2);
 fprintf(outfd,"\n\n\n");


 /* printing the first part of the header */
 current=0;
 fputs(INIT_HEADER1, outfd);
 if (DEBUG == 1) fprintf(stderr,"Dumping objects 0 and 1\n");

 /* Printing the initializion information about the objects */
 current=2;
 for (counter=current; counter<=nodes_num+1; counter++) {
   fprintf(outfd,"\tobj [%d] = Ema_Object_Create (model_id, OBJ_NT_NODE_FIXED);\n",counter);
   /*
   if (DEBUG == 1) fprintf(stderr,"Dumping object %d\n",counter);
   */
 }

 /* I have just printed the routers printing senders and receivers */
 current=nodes_num+2;
 for(i=current; i<=current+senders_num-1; i++) 
   fprintf(outfd,"\tobj [%d] = Ema_Object_Create (model_id, OBJ_NT_NODE_FIXED);\n",i);
 current=current+senders_num;
 for(i=current; i<=current+receivers_num-1; i++) 
   fprintf(outfd,"\tobj [%d] = Ema_Object_Create (model_id, OBJ_NT_NODE_FIXED);\n",i);
 current=current+receivers_num;



 for (counter=1; counter<=edges_num; counter++) {
  /* Printing first link line */
  fprintf(outfd,"\tobj [%d] = Ema_Object_Create (model_id, OBJ_NT_PTDUP_LINK);\n",current+(counter-1)*4);
  fprintf(outfd,"\tobj [%d] = Ema_Object_Create (model_id, OBJ_ATTR_PROPS);\n",current+(counter-1)*4+1);
  /*
  if (DEBUG == 1) fprintf(stderr,"Dumping object %d\n",counter);
  */
  for(i=2; i<=3; i++) {
    fprintf(outfd,"\tobj [%d] = Ema_Object_Create (model_id, OBJ_NT_POS);\n",current+(counter-1)*4+i);
    /*
    if (DEBUG == 1) fprintf(stderr,"Dumping object %d\n",counter+i);
    */
  }
 }
 
 /* updating the current pointer */
 current=current+edges_num*4;

 /* Here we need to add ETHERNETS TAP links */

  if (DEBUG == 1) printf("Senders=%d Receivers=%d Buses=%d\n", \
        senders_num,receivers_num,ethernets_num);
 /* Updating the file with ETHERNET links */
 for (counter=1; counter<=ethernets_num; counter++) {
  fprintf(outfd,"\tobj [%d] = Ema_Object_Create (model_id, OBJ_NT_BU_LINK);\n",current+(counter-1)*3);
  for(i=1; i<=2; i++) {
    fprintf(outfd,"\tobj [%d] = Ema_Object_Create (model_id, OBJ_NT_POS);\n",current+(counter-1)*3+i);
    /*
    if (DEBUG == 1) fprintf(stderr,"Dumping object %d\n",counter+i);
    */
  }
 }

 /* updating the current pointer */
 current=current+ethernets_num*3;
 /* we need this */
 start_taps=current;

  if (DEBUG == 1) printf("Senders=%d Receivers=%d Taps=%d\n", \
        senders_num,receivers_num,taps_num);
 
 /* Updating the file with the TAPS links */
 for (counter=1; counter<=taps_num; counter++) {
  fprintf(outfd,"\tobj [%d] = Ema_Object_Create (model_id, OBJ_NT_TAP);\n",current+(counter-1)*3);
  for(i=1; i<=2; i++) {
    fprintf(outfd,"\tobj [%d] = Ema_Object_Create (model_id, OBJ_NT_POS);\n",current+(counter-1)*3+i);
    /*
    if (DEBUG == 1) fprintf(stderr,"Dumping object %d\n",counter+i);
    */
  }
 }


 /* Updating information about taps and buses matrices */
 
 /* i is a variable for finding the object postition of buses */
 i=0;
 /* Senders Clients position */
 sc=0;
 /* eth_objects for correction */ 
 eth_objects=nodes_num+senders_num+receivers_num+(edges_num*4)+2;
 if (DEBUG) printf("ETH_OBJECTS %d\n",eth_objects);
 /* taps_counter is a variable for taps matrix */
 taps_counter=0;
 /* taps_object */
 taps_object=start_taps;
 /* current_client */
 current_client=nodes_num+2;
 /* Putting the ethernets BU_LINK */
 for (counter=1; counter <= ethernets_num; counter++) {
 
  /* Searching for the next available ethernet */
  while (  ((position+i)->senders == 0) &&
           ((position+i)->receivers == 0) &&
           (i<=nodes_num-1) ) i++;
  /* updating the ethernet matrix */
  if (DEBUG) printf("Node %d\n",i);
  if (DEBUG) printf("CURRENT IS %d\n",current);
  ethernets[counter-1].node=i+2;
  ethernets[counter-1].from=current+1;
  ethernets[counter-1].to=current+2;
  if (DEBUG) printf("ethernet from %d to %d\n",ethernets[counter-1].from,ethernets[counter-1].to);
  if (DEBUG) printf("ethernet %d node  %d x %f y %f\n",counter-1,i,(position+i)->x,(position+i)->y);
  ethernets[counter-1].to_x= (float) ( ((65.0/50.0) * (position+i)->x) - ((65.0/50.0) * (position+i)->y)*12.2/65 );
  ethernets[counter-1].to_y= (float) ( ((65.0/50.0) * (position+i)->y) + ((65.0/50.0) * (position+i)->x)*12.2/65);
  ethernets[counter-1].from_x= (float) ( ((65.0/50.0) * (position+i)->x) + ((65.0/50.0) * (position+i)->y)*12.2/65 );
  ethernets[counter-1].from_y= (float) ( ((65.0/50.0) * (position+i)->y) - ((65.0/50.0) * (position+i)->x)*12.2/65);
  /* skipping the positioning objects */
  current+=3;
 
  /* where to put the fucking clients */
  delta = (float) 60.2/((position+i)->senders+(position+i)->receivers);
  placement = -12.2;
  if (DEBUG) printf("PLACEMENT = %f senders %d receivers %d\n",placement,(position+i)->senders,(position+i)->receivers);
 
  /* what about the taps matrix */
  /* First lets put the router */
  /* start taps is where they start */
  taps[taps_counter].w=0;
  taps[taps_counter].bus=eth_objects;
  if (DEBUG) printf("CURRENT IS %d\n",current);
  taps[taps_counter].object=i+2;
  taps[taps_counter].from=taps_object+1;
  taps[taps_counter].to=taps_object+2;
  taps[taps_counter].to_x=(position+i)->x;
  taps[taps_counter].to_y=(position+i)->y;
  taps[taps_counter].from_x=(ethernets[counter-1].from_x+ethernets[counter-1].to_x)/2;
  taps[taps_counter].from_y=(ethernets[counter-1].from_y+ethernets[counter-1].to_y)/2;
  taps_object+=3;
  //error
  //taps_counter++;
  if (DEBUG) printf("j=%d j<=%d\n",
   taps_counter+1,taps_counter+(position+i)->senders+(position+i)->receivers);
  placement = (-1)*2.2*((position+i)->senders+(position+i)->receivers);
  for (j=taps_counter+1; j<=taps_counter+(position+i)->senders+
                                     (position+i)->receivers; j++) {
   taps[j].w=1;
   taps[j].bus=eth_objects;
   taps[j].object=current_client;
   taps[j].from=taps_object+1;
   taps[j].to=taps_object+2;
   taps[j].to_x= (float) ( ((75.0/50.0) * (position+i)->x) - ((75.0/50.0) * (position+i)->y)*placement/75 );
   taps[j].to_y= (float) ( ((75.0/50.0) * (position+i)->y) + ((75.0/50.0) * (position+i)->x)*placement/75);
   taps[j].from_x=(ethernets[counter-1].from_x+ethernets[counter-1].to_x)/2;
   taps[j].from_y=(ethernets[counter-1].from_y+ethernets[counter-1].to_y)/2;
   taps_object+=3;
   current_client++;
   if (DEBUG) printf("taps_counter_inside %d\n",taps_counter);
   sc_position[current_client-1].x= taps[j].to_x;
   sc_position[current_client-1].y= taps[j].to_y;
   placement=placement+delta;
   sc++;
   if(DEBUG) printf("SC POSITION %d %f %f\n",current_client-1,sc_position[current_client-1].x,sc_position[current_client-1].y);

  }
  taps_counter=taps_counter+1+(position+i)->senders+
                            (position+i)->receivers;
  /* Move on i for next serach */
  i++;
  /* Going for new ethernet objects */
  eth_objects+=3;
 }
 
 


 /* printing all the OBJ_ATTR_PROPS objects */
 for (counter=nodes_num+senders_num+receivers_num+3; 
      counter <= nodes_num+senders_num+receivers_num+3+edges_num*4-1;
      counter+=4) {
   fprintf(outfd,"\n\n");
   fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",counter);
   fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",counter);
   fprintf(outfd,"\t\t\"public name\",          COMP_CONTENTS, \"propagation_speed\",\n");
   fprintf(outfd,"\t\t\"default value\",        COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\t\"symbol map list\",      COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\t\"data type\",            COMP_CONTENTS, 1,\n");
   fprintf(outfd,"\t\t\"count properties\",     COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\t\"list attribute definitions\",COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\tEMAC_EOL);\n");
 }








 /* printing the second part of the header */
 /* Ready to print information about each object */
 current=0;
 fputs(INIT_HEADER2, outfd);
 

 /* Creating each of the objects positioning type etc */
 

 /* creating the node with the fault proccess inside for distributing */
 current=2;
 counter=current;
 fprintf(outfd,"\t/* assign attrs for object 'obj [2]' */\n");
 fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [2],\n");
 fprintf(outfd,"\t\t\"name\",                 COMP_CONTENTS, \"node_0\",\n");
 fprintf(outfd,"\t\t\"model\",                COMP_CONTENTS, \"ethcoax2_slip4_gtwy_base_fault\",\n");
 fprintf(outfd,"\t\t\"x position\",           COMP_CONTENTS, (double) %f,\n",(position+counter-2)->x);
 fprintf(outfd,"\t\t\"y position\",           COMP_CONTENTS, (double) %f,\n",(position+counter-2)->y);
 fprintf(outfd,"\t\t\"icon name\",            COMP_CONTENTS_SYMBOL, \"gateway_4ports\",\n");
 fprintf(outfd,"\t\t\"subnet\",               COMP_CONTENTS, obj [0],\n");
 fprintf(outfd,"\t\tEMAC_EOL);");
 fprintf(outfd,"\n\n");

 /* rest of nodes */
 current=3;
 for (counter=current; counter<=nodes_num+1; counter++) {
   fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",counter);
   fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",counter);
   fprintf(outfd,"\t\t\"name\",                 COMP_CONTENTS, \"node_%d\",\n",counter-2);
   fprintf(outfd,"\t\t\"model\",                COMP_CONTENTS, \"ethcoax2_slip4_gtwy_int\",\n");
   fprintf(outfd,"\t\t\"x position\",           COMP_CONTENTS, (double) %f,\n",(position+counter-2)->x);
   fprintf(outfd,"\t\t\"y position\",           COMP_CONTENTS, (double) %f,\n",(position+counter-2)->y);
   fprintf(outfd,"\t\t\"icon name\",            COMP_CONTENTS_SYMBOL, \"gateway_4ports\",\n");
   fprintf(outfd,"\t\t\"subnet\",               COMP_CONTENTS, obj [0],\n");
   fprintf(outfd,"\t\tEMAC_EOL);");
   fprintf(outfd,"\n\n");
 }


 /*
 if (DEBUG) {
  for(i=0; i<=sc-1; i++) {
   printf("SC %d x %f y %f\n",i,sc,sc);
  }
 }
 */



 /* I have just printed the properties of the routers */
 /* I continue with the senders and receivers */
 current=nodes_num+2;
 for(i=current; i<=current+senders_num-1; i++) {
  fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",i);
  fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",i);
  fprintf(outfd,"\t\t\"name\",                 COMP_CONTENTS, \"node_%d\",\n",i-2);
  fprintf(outfd,"\t\t\"model\",                COMP_CONTENTS, \"ethcoax_wkstn_int\",\n");
  fprintf(outfd,"\t\t\"x position\",           COMP_CONTENTS, (double) %f,\n",sc_position[i].x);
  fprintf(outfd,"\t\t\"y position\",           COMP_CONTENTS, (double) %f,\n",sc_position[i].y);
  if(DEBUG) printf("SC PRINTED POSITION %d %f %f\n",i,sc_position[i].x,sc_position[i].y);
  fprintf(outfd,"\t\t\"icon name\",            COMP_CONTENTS_SYMBOL, \"wkstn\",\n");
  fprintf(outfd,"\t\t\"subnet\",               COMP_CONTENTS, obj [0],\n");
  fprintf(outfd,"\t\tEMAC_EOL);\n\n\n");
 }

 current=current+senders_num;
 for(i=current; i<=current+receivers_num-1; i++) {
  fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",i);
  fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",i);
  fprintf(outfd,"\t\t\"name\",                 COMP_CONTENTS, \"node_%d\",\n",i);
  fprintf(outfd,"\t\t\"model\",                COMP_CONTENTS, \"ethcoax_server_int\",\n");
  fprintf(outfd,"\t\t\"x position\",           COMP_CONTENTS, (double) %f,\n",sc_position[i].x);
  fprintf(outfd,"\t\t\"y position\",           COMP_CONTENTS, (double) %f,\n",sc_position[i].y);
  if(DEBUG) printf("SC PRINTED POSITION %d %f %f\n",i,sc_position[i].x,sc_position[i].y);
  fprintf(outfd,"\t\t\"icon name\",            COMP_CONTENTS_SYMBOL, \"server\",\n");
  fprintf(outfd,"\t\t\"subnet\",               COMP_CONTENTS, obj [0],\n");
  fprintf(outfd,"\t\tEMAC_EOL);\n\n\n");
 }
 current=current+receivers_num;
 


 /* Creating each of the objects links properties */
 for (counter=1; counter<=edges_num; counter++) {
   fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",current);
   fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",current);
   fprintf(outfd,"\t\t\"name\",                 COMP_CONTENTS, \"duplex_%d\",\n",counter-1);
   fprintf(outfd,"\t\t\"model\",                COMP_CONTENTS, \"sl_ip\",\n");
   /* if we are using an ethernet interface get the next serial */
   if ((position+(edges->from))->tlinks == 4) (position+(edges->from))->tlinks+=2;
   fprintf(outfd,"\t\t\"transmitter a\",        COMP_CONTENTS, \"node_%d.pt_%d_0\",\n",edges->from,(position+(edges->from))->tlinks);
   /* Add one to the links */
   (position+(edges->from))->tlinks++;
   /* if we are using an ethernet interface get the next serial */
   if((position+(edges->to))->tlinks == 4) (position+(edges->to))->tlinks+=2; 
   fprintf(outfd,"\t\t\"transmitter b\",        COMP_CONTENTS, \"node_%d.pt_%d_0\",\n",edges->to,(position+(edges->to))->tlinks);
   (position+(edges->to))->tlinks++;
   fprintf(outfd,"\t\t\"receiver a\",           COMP_CONTENTS, \"node_%d.pr_%d_0\",\n",edges->from,(position+(edges->from))->rlinks);
   (position+(edges->from))->rlinks++;
   fprintf(outfd,"\t\t\"receiver b\",           COMP_CONTENTS, \"node_%d.pr_%d_0\",\n",edges->to,(position+(edges->to))->rlinks);
   (position+(edges->to))->rlinks++;
   fprintf(outfd,"\t\t\"data rate\",            COMP_CONTENTS_SYMBOL, \"DS0\",\n");
   fprintf(outfd,"\t\t\"data rate\",            COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\t\"packet formats\",       COMP_CONTENTS, \"ip3_dgram\",\n");
   fprintf(outfd,"\t\t\"packet formats\",       COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\t\"delay\",                COMP_CONTENTS_SYMBOL, \"Distance Based\",\n");
   fprintf(outfd,"\t\t\"delay\",                COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\t\"user id\",              COMP_CONTENTS, (int) %d,\n",counter);
   fprintf(outfd,"\t\t\"txdel model\",          COMP_CONTENTS, \"dpt_txdel_ip\",\n");
   fprintf(outfd,"\t\t\"txdel model\",          COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\t\"propdel model\",        COMP_CONTENTS, \"dpt_new_propdel\",\n");
   fprintf(outfd,"\t\t\"propdel model\",        COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\tEMAC_EOL);\n");
   fprintf(outfd,"\n");
 
   /* same link object more attributes */
   fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",current);
   fprintf(outfd,"\t\t\"color\",                COMP_CONTENTS, 63,\n");
   fprintf(outfd,"\t\t\"color\",                COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\t\"site a\",               COMP_CONTENTS, obj [%d],\n",(edges->from)+2);
   fprintf(outfd,"\t\t\"site b\",               COMP_CONTENTS, obj [%d],\n",(edges->to)+2);
   fprintf(outfd,"\t\t\"path\",                 COMP_ARRAY_CONTENTS (0), obj [%d],\n",current+2);
   fprintf(outfd,"\t\t\"path\",                 COMP_ARRAY_CONTENTS (1), obj [%d],\n",current+3);
   fprintf(outfd,"\t\t\"subnet\",               COMP_CONTENTS, obj [0],\n");
   fprintf(outfd,"\t\tEMAC_EOL);\n");
   fprintf(outfd,"\n\n");
   /* move the pointer to the matrix */
   edges=edges+1;
   /* the following two objects are the positioning */
   current+=4;
 }

 /* i is a variable for finding the object postition of buses */
 i=0;
 /* taps_counter is a variable for taps matrix */
 taps_counter=0;
 /* taps_object */
 taps_object=start_taps;
 /* current_client */
 current_client=nodes_num+2;
 /* Putting the ethernets BU_LINK */
 for (counter=1; counter <= ethernets_num; counter++) {
  fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",current);
  fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",current);
  fprintf(outfd,"\t\t\"name\",                 COMP_CONTENTS, \"bus_%d\",\n",counter-1);
  fprintf(outfd,"\t\t\"model\",                COMP_CONTENTS, \"eth_coax\",\n");
  fprintf(outfd,"\t\t\"data rate\",            COMP_CONTENTS, (double) 1e+07,\n");
  fprintf(outfd,"\t\t\"data rate\",            COMP_INTENDED, EMAC_DISABLED,\n");
  fprintf(outfd,"\t\t\"packet formats\",       COMP_CONTENTS, \"ethernet\",\n");
  fprintf(outfd,"\t\t\"packet formats\",       COMP_INTENDED, EMAC_DISABLED,\n");
  fprintf(outfd,"\t\t\"delay\",                COMP_CONTENTS_SYMBOL, \"5.1282E-09\",\n");
  fprintf(outfd,"\t\t\"delay\",                COMP_INTENDED, EMAC_DISABLED,\n");
  fprintf(outfd,"\t\t\"subnet\",               COMP_CONTENTS, obj [0],\n");
  fprintf(outfd,"\t\t\"path\",                 COMP_ARRAY_CONTENTS (0), obj [%d],\n",current+1);
  fprintf(outfd,"\t\t\"path\",                 COMP_ARRAY_CONTENTS (1), obj [%d],\n",current+2);
  fprintf(outfd,"\t\t\"taps\",                 COMP_INTENDED, EMAC_DISABLED,\n");
  fprintf(outfd,"\t\tEMAC_EOL);\n\n");
  /* skipping the positioning objects */
  current+=3;


 }


 /* Debugging for ethernet and taps */

 if (DEBUG) {
   printf("ETHERNETS\n-----------\n");
   for(i=0;i<=ethernets_num-1;i++) {
     printf("bus=%d node=%d from=%d to=%d\n",i,ethernets[i].node,ethernets[i].from,ethernets[i].to);
   }
   printf("TAPS\n-----------\n");
   printf("taps_num %d taps_counter %d\n",taps_num,taps_counter);
   for(i=0;i<=taps_num-1;i++) {
     printf("tap=%d object=%d, w=%d bus=%d from=%d to=%d\n",i,taps[i].object,taps[i].w,taps[i].bus,taps[i].from,taps[i].to);
   }
 }

 if (DEBUG) printf("Current %d\n", current);

 /* object number */
 counter=current;
 /* Printing out the taps */
 for (i=0;i<=taps_num-1;i++) {

   fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",counter);
   fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",counter); 
   fprintf(outfd,"\t\t\"name\",                 COMP_CONTENTS, \"tap_%d\",\n",i);
   fprintf(outfd,"\t\t\"model\",                COMP_CONTENTS, \"eth_tap\",\n");
   if (taps[i].w!=0) {
      fprintf(outfd,"\t\t\"transmitter\",          COMP_CONTENTS, \"node_%d.bus_tx_0_0\",\n",taps[i].object-2);
      fprintf(outfd,"\t\t\"receiver\",             COMP_CONTENTS, \"node_%d.bus_rx_0_0\",\n",taps[i].object-2);
   } else {
      fprintf(outfd,"\t\t\"transmitter\",          COMP_CONTENTS, \"node_%d.bus_tx_4_0\",\n",taps[i].object-2);
      fprintf(outfd,"\t\t\"receiver\",             COMP_CONTENTS, \"node_%d.bus_rx_4_0\",\n",taps[i].object-2);
     }
   fprintf(outfd,"\t\t\"site\",                 COMP_CONTENTS, obj [%d],\n",taps[i].object);
   fprintf(outfd,"\t\t\"path\",                 COMP_ARRAY_CONTENTS (0), obj [%d],\n",taps[i].from);
   fprintf(outfd,"\t\t\"path\",                 COMP_ARRAY_CONTENTS (1), obj [%d],\n",taps[i].to);
   fprintf(outfd,"\t\t\"bus\",                  COMP_CONTENTS, obj [%d],\n",taps[i].bus);
   fprintf(outfd,"\t\t\"subnet\",               COMP_CONTENTS, obj [0],\n");
   fprintf(outfd,"\t\tEMAC_EOL);\n\n");
   counter+=3;
 }
 /* move the current pointer */
 current=counter;

 if (DEBUG) printf("Current %d\n", current);

 /* Restoring original edges matrix */
 edges=original_edges;
 /* generating position objects of the links */
 current=nodes_num+senders_num+receivers_num+3;

 if (DEBUG) printf("Current %d\n", current);
  
 /* printing edges information location */
 for (counter=0; counter<=edges_num-1; counter++) {
    /* printing source coordinates */
    fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",current+1);
    fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",current+1);
    fprintf(outfd,"\t\t\"x\",                    COMP_CONTENTS, (double) %f,\n",(position+edges->from)->x);
    fprintf(outfd,"\t\t\"y\",                    COMP_CONTENTS, (double) %f,\n",(position+edges->from)->y);
    fprintf(outfd,"\t\tEMAC_EOL);\n");
    fprintf(outfd,"\n\n");

    /* Printing destination coordinates */
    fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",current+2);
    fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",current+2);
    fprintf(outfd,"\t\t\"x\",                    COMP_CONTENTS, (double) %f,\n",(position+edges->to)->x);
    fprintf(outfd,"\t\t\"y\",                    COMP_CONTENTS, (double) %f,\n",(position+edges->to)->y);
    fprintf(outfd,"\t\tEMAC_EOL);\n");
    fprintf(outfd,"\n\n");

    /* Go to the next position of the matrix edges */
    edges++;
    current+=4;
  
 }


 if (DEBUG) printf("Current %d\n", current);

 /* printing location for the buses */
 for (counter=0; counter<=ethernets_num-1; counter++) {

  fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",current);
  fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",current);
  fprintf(outfd,"\t\t\"x\",                    COMP_CONTENTS, (double) %f,\n",ethernets[counter].from_x);
  fprintf(outfd,"\t\t\"y\",                    COMP_CONTENTS, (double) %f,\n",ethernets[counter].from_y);
  fprintf(outfd,"\t\tEMAC_EOL);\n\n");
 
  fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",current+1);
  fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",current+1);
  fprintf(outfd,"\t\t\"x\",                    COMP_CONTENTS, (double) %f,\n",ethernets[counter].to_x);
  fprintf(outfd,"\t\t\"y\",                    COMP_CONTENTS, (double) %f,\n",ethernets[counter].to_y);
  fprintf(outfd,"\t\tEMAC_EOL);\n\n");
 
  current+=3;
 
 }

 if (DEBUG) printf("Current %d\n", current);
 
 /* printing location for the taps */
 for (counter=0; counter<=taps_num-1; counter++) {

  fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",current);
  fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",current);
  fprintf(outfd,"\t\t\"x\",                    COMP_CONTENTS, (double) %f,\n",taps[counter].from_x);
  fprintf(outfd,"\t\t\"y\",                    COMP_CONTENTS, (double) %f,\n",taps[counter].from_y);
  fprintf(outfd,"\t\tEMAC_EOL);\n\n");
 
  fprintf(outfd,"\t/* assign attrs for object 'obj [%d]' */\n",current+1);
  fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",current+1);
  fprintf(outfd,"\t\t\"x\",                    COMP_CONTENTS, (double) %f,\n",taps[counter].to_x);
  fprintf(outfd,"\t\t\"y\",                    COMP_CONTENTS, (double) %f,\n",taps[counter].to_y);
  fprintf(outfd,"\t\tEMAC_EOL);\n\n");
 
  current+=3;
 
 }

 if (DEBUG) printf("Current %d\n", current);


 /* printing the FOOTER of the program */
 current=0;
 fputs(FOOTER, outfd);




 /* print rest of OBJ_ATTR_PROPS attributes */
 current=nodes_num+2+senders_num+receivers_num;
 for (counter=0 ; counter <= edges_num-1; counter++) {
   fprintf(outfd,"\t/* promoted attrs for object 'obj [%d]' */\n",current);
   fprintf(outfd,"\tEma_Object_Prom_Attr_Set (model_id, obj [%d],\n",current);
   fprintf(outfd,"\t\t\"Propagation Speed\", obj [%d]);\n",current+1);
   fprintf(outfd,"\tEma_Object_Attr_Set (model_id, obj [%d],\n",current);
   fprintf(outfd,"\t\t\"Propagation Speed\",    COMP_PROMOTE, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\t\"Propagation Speed\",    COMP_CONTENTS_SYMBOL, \"Speed of Light\",\n");
   fprintf(outfd,"\t\t\"Propagation Speed\",    COMP_INTENDED, EMAC_DISABLED,\n");
   fprintf(outfd,"\t\tEMAC_EOL);\n\n\n");
   current+=4;
   
 }

 /* writing at the end of the file the name */ 
 fprintf(outfd,"\t/* write the model to application-readable form */\n");
 fprintf(outfd,"\tEma_Model_Write (model_id, \"");
 bzero((char *) &buffer,sizeof(buffer));
 strncat((char *) &buffer, output, strlen(output));
 fputs((char *)&buffer,outfd);
 fprintf(outfd,"\");\n\n\t}\n\n");


}



int getnumber(int nodes_num)
{
  struct timeval now;
  int rand_num;
  int value;

  gettimeofday(&now,0);
  srand((unsigned int) now.tv_usec);
  rand_num = rand();
  /*
  if (DEBUG == 1) 
    printf("Using rand_num=%d\n",rand_num);
  */
  /* sending a random variable of one of the nodes */
  value=rand_num/100;
  if (value <= nodes_num) return(value);
  value=value/10;
  if (value <= nodes_num) return(value);
  value=value/10;
  if (value <= nodes_num) return(value);
  value=value/10;
  if (value==0) value=1;
  return(value);

}


void construct_opnet_file (int nodes_num, int edges_num, char *output, int senders_frac, int receivers_frac)
{
 int object_num;
 char buffer[255];
 int i,counter;
 position_t position[nodes_num];
 edge_t edges[edges_num];
 int nada, int_x, int_y;
 int senders_num, receivers_num;
 int getnum;

 if (DEBUG == 1) fprintf(stderr,"Just entered construct_opnet_file\n");

 /* Input file is aleady opened */
 outfd=fopen(output,"w");
 if (outfd==NULL) {
  printf("Error opening output file\n");
  exit(-1);
 }


 if (DEBUG == 1) 
  fprintf(stderr,"Starting construct_opnet_file with \
   nodes=%d infd=%d outfd=%d\n",nodes_num,infd,outfd);
 
 /*
 if (DEBUG == 1) system("ls");
 */

 /* Read until to find NODES */
 bzero(&buffer,sizeof(buffer));
 fgets((char *) &buffer, sizeof(buffer),(FILE *) infd);
 while((strcmp(buffer,"")!=0) && (memcmp(&buffer,"# NODES",7)!=0)) {
  bzero(&buffer,sizeof(buffer));
  fgets((char *) &buffer, sizeof(buffer),(FILE *) infd);
  /*
  if (DEBUG == 1) puts((char *) &buffer);
  */
 }
 /* Read five more lines in order to start getting POSITIONING info */
 for (i=1;i<=5;i++) {
  fgets((char *) &buffer, sizeof(buffer),(FILE *) infd);
  /* 
  if (DEBUG == 1) puts((char *) &buffer);
  */
 }
  /*
  if (DEBUG == 1) fprintf(stderr,"Printing locations for %d nodes\n",nodes_num);
  */
 /* Get positioning info and store them in the matrix 
    node_id x_position y_position */
 for(i=0;i<=nodes_num-1;i++) {
  fscanf(infd,"%d %d %d %d",&nada,&int_x,&int_y,&nada);
  position[i].x = ((float) ((float) int_x / 360) - 180);
  position[i].y = ((float) ((float) int_y / 180) - 90);
  position[i].tlinks=0;
  position[i].rlinks=0;
  /*
  if (DEBUG == 1) fprintf(stderr,"%f %f\n",position[i].x,position[i].y);
  */
 }

 /* Lets do work for senders and receivers */
 /* find the number of them and update the table */
 /* flush the senders receivers inside the position table */
 for (i=0; i<= nodes_num-1; i++) {
  position[i].senders=0;
  position[i].receivers=0;
 }
 /* Now find out the senders number */
 senders_num=(int) ((float)(senders_frac*nodes_num)/(float)100);
 receivers_num=(int) ((float)(receivers_frac*nodes_num)/(float)100);
 /* Have at least one sender and one receiver */
 if (senders_num == 0) senders_num++;
 if (receivers_num == 0) receivers_num++;

 if (DEBUG == 1) 
    printf("senders=%d\nreceivers=%d\n",senders_num,receivers_num);

 /* Updating Matrix of the senders */
 for (i=1; i<= senders_num; i++) {
    getnum=getnumber(nodes_num)-1;
    if (getnum < 0) getnum++;
    if (DEBUG == 1) printf("nodes_num=%d position=%d\n",nodes_num,getnum);
    position[getnum].senders++;
 }

 /* Updating matrix of the receivers */
 for (i=1; i<= receivers_num; i++) {
    getnum=getnumber(nodes_num)-1;
    if (getnum < 0) getnum++;
    if (DEBUG == 1) printf("nodes_num=%d position=%d\n",nodes_num,getnum);
    position[getnum].receivers++;
 }

 /*
 if (DEBUG == 1) {
  for(i=0; i<=nodes_num-1; i++)
   printf("Node=%d x=%f y=%f senders=%d receivers=%d\n", \
    i,position[i].x,position[i].y,position[i].senders,position[i].receivers);
 }
 */


 /* Read until to find MAN 0 */
 bzero(&buffer,sizeof(buffer));
 fgets((char *) &buffer, sizeof(buffer),(FILE *) infd);
 while((strcmp(buffer,"")!=0) && (memcmp(&buffer,"# MAN 0",7)!=0)) {
  bzero(&buffer,sizeof(buffer));
  fgets((char *) &buffer, sizeof(buffer),(FILE *) infd);
  /*
  if (DEBUG == 1) puts((char *) &buffer);
  */
 }
 /* Read Next Line and we are ready for reading the Edges */
 fgets((char *) &buffer, sizeof(buffer),(FILE *) infd);

 /* First we need to know  */

 /*
 if (DEBUG == 1) fprintf(stderr,"Printing edges for %d nodes\n",edges_num);
 */
 /* Get edges info and store them in the matrix edges */
 for(i=0;i<=edges_num-1;i++) {
  fscanf(infd,"%d %d %d %d %d %d %d",&edges[i].from,&edges[i].to,
    &edges[i].delay, &edges[i].bandwidth, &nada, &nada, &edges[i].state);

  /* In case we have the bad link reread from file */
  if (edges[i].state==3) {
   fscanf(infd,"%d %d %d %d %d %d %d",&edges[i].from,&edges[i].to,
    &edges[i].delay, &edges[i].bandwidth, &nada, &nada, &edges[i].state);
  }
  edges[i].from-=1;
  edges[i].to-=1;
  if (DEBUG == 1) 
     fprintf(stderr,"%d %d %d %d %d %d\n",edges[i].from,edges[i].to,
             edges[i].delay, edges[i].bandwidth, edges[i].state);
 }

 /* we do not need any more input */
 close(infd);

 /* calculate the exact potition of the routers */ 
 calculate_position(nodes_num,(position_t *)&position[0],50);

 if (DEBUG == 1) {
  for (nada=0; nada <= nodes_num-1; nada++) {
   printf("outside node %d x=%f y=%f senders=%d receivers=%d\n", \
      nada,position[nada].x,position[nada].y, \
      position[nada].senders,position[nada].receivers);
  }
 }

 /* counting the ETHERNET TAPS links */
 ethernets_num = 0; 
 taps_num=0;
 for (i=0; i<=nodes_num-1; i++) {
   if ((position[i].senders != 0) ||
       (position[i].receivers != 0)) {
           ethernets_num++;
   }
   if (position[i].senders != 0)   taps_num+=(position[i].senders+1);
   if (position[i].receivers != 0) taps_num+=(position[i].receivers+1);
   if ((position[i].senders != 0) &&
       (position[i].receivers != 0)) taps_num--;

 }

 /* finally creating the EMA code */
 create_ema_code(nodes_num,(position_t *)&position[0],edges_num,(edge_t *)&edges[0], output, senders_num, receivers_num);
 close(outfd);

}




 /* Start working for the fault generation */


long get_random_number(long sim_length)
{
  struct timeval now;
  long value;

  gettimeofday(&now,0);
  srandom((unsigned int) now.tv_usec);
  value = random();
  if (value <= (long) sim_length) return(value);
  value=value/10;
  if (value <= (long) sim_length) return(value);
  value=value/10;
  if (value <= (long) sim_length) return(value);
  value=value/10;
  if (value <= (long) sim_length) return(value);
  value=value/10;
  if (value <= (long) sim_length) return(value);
  value=value/10;
  if (value <= (long) sim_length) return(value);
  value=value/10;
  if (value <= (long) sim_length) return(value);
  value=value/10;
  if (value <= (long) sim_length) return(value);
  value=value/10;
  if (value <= (long) sim_length) return(value);
  value=value/10;
  if (value <= (long) sim_length) return(value);
  value=value/10;
  /*
  while (value >= (long) 100*sim_length) {
    value = random();
  }
  */
  return(value);
}









void make_random_failure_file(int sim_length,int max_failures,int max_time,int edges_num)
{
 failure_t failure[max_failures]; 
 int counter;
 int i,j;
 long tmp;
 int rest;
 int flag;
 int value;
 
 /* creating the failures time */
 for (counter=0; counter<=max_failures-1;counter++) failure[counter].time 
                                                  = get_random_number((long) 100*sim_length);
 /*
 if (DEBUG) {
   for (counter=0; counter<=max_failures-1;counter++) printf("Counter value %d = %d\n",
                                                                counter,failure[counter].time);
 }
 */


 /* sorting the numbers */
 for (i=0; i<=max_failures-1;i++) {
  for (j=i+1;j<=max_failures-1;j++) {
   if (failure[i].time>=failure[j].time) {
     tmp = failure[j].time;
     failure[j].time = failure[i].time;
     failure[i].time = tmp; 
   }
  }
 }

 
 /*
 if (DEBUG) {
   for (counter=0; counter<=max_failures-1;counter++) printf("Counter value %d = %d\n",
                                                                counter,failure[counter].time);
 }
 */


 rest=max_failures/2;
 /* Ready to distribute the simulations */
 for (counter=0; counter<=max_failures/2-1; counter++) {
    flag=0;
    value = (int)get_random_number((long) edges_num);
    while (flag==0) {
     for (i=0;i<=counter || value==failure[i].user_id;i++)  
     if(value != failure[i].user_id) {
       flag=1;
     }
     else {
          // value = (int)get_random_number((long) edges_num);
           value=value+2;
           if (value > edges_num) value=1;
          }
    }
    failure[counter].user_id = value;
    failure[counter].event=1;
    failure[rest].user_id = failure[counter].user_id;
    failure[rest].event=0;
    rest++;
 }


 /* Matrix to enter the array */
 if (DEBUG) {
   printf("Edges Number %d\n",edges_num);
   for (counter=0; counter<=max_failures-1;counter++) {
     printf("time=%d user_id=%d",failure[counter].time,failure[counter].user_id);
     if (failure[counter].event==1) printf(" event=failure\n");
      else printf(" event=recovery\n");
   }
 }

 outfd = fopen("script","w");
   fprintf(outfd,"# script file for link failures\n");
   fprintf(outfd,"# Times are expexted in order\n");
   fprintf(outfd,"# Simulation time %d\n",sim_length);
   fprintf(outfd,"#\n#\n#\n");
   fprintf(outfd,"# time\t\t\tuser_id\t\tevent\n");
   for (counter=0; counter<=max_failures-1;counter++) {
     fprintf(outfd,"  %f\t\t%d\t\t",(float) failure[counter].time/100,failure[counter].user_id);
     if (failure[counter].event==1) fprintf(outfd,"failure\n");
      else fprintf(outfd,"recovery\n");
   }
 close(outfd);

}




void make_fixed_failure_file(int sim_length,char *get_failures_file,int lines,int edges_num)
{
 int counter;
 float start_time;
 float end_time;
 int user_id;
 float time;
 long ltmp;
 int itmp;
 int i,j;
 failure_t failure[lines*2];
 /* format of the file we are going to read */
 /* starting_time ending_time user_id       */
 /*      float       float      int         */
 infd = fopen(get_failures_file,"r");
 counter=0;
 while ((fscanf(infd,"%f %f %d",&start_time,&end_time,&user_id)) >=0) {
   if (DEBUG) printf("%f %f %d\n",start_time,end_time,user_id);
   failure[counter].time = (long) (start_time*100);
   failure[counter].user_id = user_id;
   failure[counter].event = 1;
   failure[counter+1].time = (long) (end_time*100);
   failure[counter+1].user_id = user_id;
   failure[counter+1].event = 0;
   counter+=2;
 }
 close(infd);

 /* sorting the numbers */
 for (i=0; i<=lines*2-1;i++) {
  for (j=i+1;j<=lines*2-1;j++) {
   if (failure[i].time>=failure[j].time) {
     /* swap the time */
     ltmp = failure[j].time;
     failure[j].time = failure[i].time;
     failure[i].time = ltmp; 
     /* swap the user_id */
     itmp = failure[j].user_id;
     failure[j].user_id = failure[i].user_id;
     failure[i].user_id = itmp; 
     /* swap the event type */
     itmp = failure[j].event;
     failure[j].event = failure[i].event;
     failure[i].event = itmp; 
   }
  }
 }

 /*
 if (DEBUG) {
   for (counter=0; counter<=lines*2-1;counter++) printf("Counter value %d time %d userid %d type %d\n",
                     counter,failure[counter].time,failure[counter].user_id,failure[counter].event);
 }
 */

 outfd = fopen("script","w");
   fprintf(outfd,"# script file for link failures\n");
   fprintf(outfd,"# Times are expexted in order\n");
   fprintf(outfd,"# Simulation time %d\n",sim_length);
   fprintf(outfd,"#\n#\n#\n");
   fprintf(outfd,"# time\t\t\tuser_id\t\tevent\n");
   for (counter=0; counter<=lines*2-1;counter++) {
     fprintf(outfd,"  %f\t\t%d\t\t",(float) failure[counter].time/100,failure[counter].user_id);
     if (failure[counter].event==1) fprintf(outfd,"failure\n");
      else fprintf(outfd,"recovery\n");
   }
 close(outfd);


}





int main(int argc, char *argv[])
{

 int nodes_num;
 int edges_num;
 int senders_frac;
 int receivers_frac;
 int err;
 int max_failures = 0;
 int max_time = 0;
 int sim_length;
 char *get_failures_file;
 char *number;
 char *redundancy1;
 char *redundancy2;
 char *output;
 char buffer[255];
 int counter;
 float time;
 int user_id;


 nodes_num = atoi(argv[1]); 
 
 /* Usage: a.out <node_number> <filename> <redanduncy1> <redanduncy2> 
                 <fraction_of_senders> <fraction of receivers> 
                 <simulation length> <maximum numbers of failure> 
                 <maximum time of failure>*/

 /* Usage: a.out <node_number> <filename> <redanduncy1> <redanduncy2> 
                 <fraction_of_senders> <fraction of receivers> 
                 <simulation length> <file with failures> */

 number = argv[1];
 output = argv[2];
 redundancy1 = argv[3];
 redundancy2 = argv[4];
 senders_frac = atoi(argv[5]);
 receivers_frac = atoi(argv[6]);
 

 /* Building a topology */
 printf ("Running tiers algorithm for %d nodes \n",nodes_num);
 err = run_algorithm(number,redundancy1,redundancy2);
 if (err < 0) {
   fprintf(stderr,"Error executing the run algorithm\n");
   exit(-1);
 }

 if (DEBUG == 1) printf ("Ready to execute the transform\n");
 find_edges_number(&edges_num);
 if (DEBUG == 1) 
   fprintf(stderr,"Ready to call contruct_opnet_file with params\n\
    nodes_num=%d\n    edges_num=%d\n",nodes_num,edges_num);

  bzero(&buffer,sizeof(buffer));
  fgets((char *) &buffer, sizeof(buffer), infd);
  if (DEBUG == 1) puts((char *) &buffer);
  bzero(&buffer,sizeof(buffer));
  fgets((char *) &buffer, sizeof(buffer), infd);
  if (DEBUG == 1) puts((char *) &buffer);

 /* Before Constructing the opnet file we need to find the number of
    sender and receivers */
 construct_opnet_file(nodes_num, edges_num, output, senders_frac, receivers_frac); 
 
 


 /* creating the falut generations file */
 sim_length = atoi(argv[7]);

 if ((max_failures=atoi(argv[8])) > 0) {
    max_time = atoi(argv[9]);
    make_random_failure_file(sim_length,max_failures,max_time,edges_num);
 } else {
    get_failures_file = argv[8];
    infd = fopen(argv[8],"r");
    counter=0;
    while ((fscanf(infd,"%f %f %d",&time,&time,&user_id)) >=0) {
      if (DEBUG) printf("%f %f %d\n",time,time,user_id);
      counter++;
    }
      if (DEBUG) printf("Total Lines %d\n",counter);
    close(infd);
    make_fixed_failure_file(sim_length,get_failures_file,counter,edges_num);
 }
 
 /* call the main function for creating the fault */
 printf("EDGES num %d\n",edges_num);















/*
  switch (argc) {
    case 1: {
     // using default values
     break; 
    }
    case 3: {
     strcpy(groupaddr, argv[1]);
     strcpy(groupport, argv[2]);
     break; 
    }
    default: {
     printf("Usage: rtprec [groupaddress] [goupport]\n");
     exit(1);
     break;
    }
  } 
*/





  return(0);
}
